import 'package:async_injector/async_injector.dart';

class DI {
  static Provider instance;

  static Future initComponent() async {
    var component = ProviderBuilder();

    component
      ..dependency(DateTime.now().millisecondsSinceEpoch.toString())
      ..moduleImpl((provider) => Future.value(int.parse(provider.get())))
      ..moduleImpl(
          (provider) => DateTime.fromMicrosecondsSinceEpoch(provider.get()));

    DI.instance = await component.build();
  }

  static T get<T>() => instance.get<T>();
}
