import 'package:async_injector/async_injector.dart';
import 'package:async_injector/provide/provider.dart';
import 'module.dart';

/// implementation of the init method from [Module]
/// used in [ProviderBuilder] for easy module creation
class ModuleImpl<T> extends Module<T> {
  final Function(Provider) onInit;

  ModuleImpl(this.onInit) : assert(onInit != null);

  dynamic init(Provider provider) => onInit(provider);
}
